from pytest import mark
from secrets import token_hex

from app.schemas import *
from database.models import *
from tests import client
from tests.queries_test import get_test_db


def test_registration():
    user = {
        "full_name": "Bilal Balaperdida",
        "email": "oyvey@hotmail.com",
        "password": "lifeisabitch",
        "gender": 1,
        "mobile": "+212655778899",
        "user_type": 1,
        "lang_type": 1,
        "device_type": 1,
        "device_id": token_hex(16),
        "city_id": 5,
    }
    response = client.post("/register", json=user)
    assert response.status_code == 200


@mark.skip(reason="not implemented")
def test_login():
    user = {
        "email": "12@gmail.com",
        "password": "odyfo2020",
        "device_id": "fEll6hxazGQ:APA91bFpsB44ZHgjUItYOKTTmUxxkJsWiuaeojdxiTLVbz-AwN90XwLvpA6nRQoLrUYaF-HoHTz4Vc5S0VlqemerJ6MjG4zqwfNYB75whQVQI1M29yhMc3oFdl1me2zP_RY2dXbfx7UW",
        "lang_type": 2,
        "user_type": 1,
    }
    response = client.post("/login", json=user)
    assert response.status_code == 200


def test_otp_verification(get_test_db):
    user = get_test_db.query(Users).filter(Users.email == "oyvey@hotmail.com").first()
    data = {
        "access_key": user.access_key,
        "otp": user.otp,
    }
    response = client.post("/otpVerification", json=data)
    assert response.status_code == 200


def test_resend_otp():
    data = {
        "email": "testorganizer@odyfo.com",
    }
    response = client.post("/resendOTP", json=data)
    assert response.status_code == 200
